PROGRAM main

    USE types_module
    USE tools_module

    IMPLICIT NONE
    REAL(dp), DIMENSION(9)                      ::  inputpar 
    INTEGER, DIMENSION(2)                       ::  temp                !how many states do you want to have
    ! characteristics that we target for the continuous process
    INTEGER                                     ::  iter                ! number of iterations for amoeba to find a minimum
    REAL(dp)                                    ::  ftol,weight
    INTEGER, PARAMETER                          ::  t=1000000           ! number of realizations of the continuous process, just to specify the region that we are gonna take random numbers for the simplex
    REAL(dp), DIMENSION(t)                      ::  process             ! the realizations of the continuous process
    REAL(dp), DIMENSION(t-1)                    ::  DiffProcess         ! the first difference of the realized cont. process
    INTEGER                                     ::  n                   ! number of states used for the discrete approximation
    REAL(dp), DIMENSION(:,:), ALLOCATABLE       ::  transition          ! the transition matrix of the approximating markov process
    REAL(dp), DIMENSION(:,:), ALLOCATABLE       ::  states
    REAL(dp), DIMENSION(:), ALLOCATABLE         ::  yy
    REAL(dp), DIMENSION(100)                    ::  best
    REAL(dp), DIMENSION(9)                      ::  Targets             ! the vector of moments
	REAL(dp), DIMENSION(9)                      ::  mm1             ! the vector of moments
    INTEGER                                     ::  i,j,k,h,ii             ! counter
    REAL(dp), DIMENSION(:,:), ALLOCATABLE       ::  RandomRestarts      ! vector to store initial random simplex for random restarts
    REAL(dp), DIMENSION(:), ALLOCATABLE         ::  Results             ! vector to store initial random simplex for random restarts
    INTEGER                                     ::  clock_start,clock_end,clock_rate
    REAL(dp)                                    ::  elapsed_time
    CHARACTER(2)                                ::  name
    REAL(dp), DIMENSION(9)                      ::  detail             ! the vector of moments
    REAL(dp)                                    ::  temp1,minpro,maxpro,start,finish
    INTEGER                                     ::  info
    CHARACTER(4)                                ::  stopcond
    CHARACTER(3)                                ::  s2
    CHARACTER(5)                                ::  s1    
	REAL(dp), DIMENSION(:,:), ALLOCATABLE       ::  Results_vector,states_vector
	
	
	
    inputpar(1)=0.0335638760005817_dp          ! mean1
    inputpar(2)=0.0573592172915801_dp          ! variance1
    inputpar(3)=-0.302074884005235_dp          ! mean2
    inputpar(4)=1.67485882854210_dp          ! variance2
    inputpar(5)=inputpar(3)		      		   ! mean3    
    inputpar(6)=inputpar(4)         		! variance3
    inputpar(7)=0.9_dp   					 ! p1
    inputpar(8)=0.05_dp  					  ! p2
    inputpar(9)=0.50_dp          			 ! rho!
	
	WRITE(s1,'(F5.3)')inputpar(9)
    s2=s1(3:5)

    
    ! specify the cardinality of the state space
    ! if you want to try with several different cardinality
    ! for example 3 and 5, make t of dimension 2 and specify
    ! temp=(/3,5/)
    
    temp=(/5,9/)
    
    ! specify the number of random restarts
    ! see that the algorithm restarts for a total of 2*k times
    ! k during the initial global non-focused search
    ! and k for the final focused search
    
    k=200 !Must be a multiple of 100
    
    ! computing the moments from the continuous process
    Targets=ParToMom(inputpar)
    ! 1 mean of the process
    ! 2 variance of the process
    ! 3 skewness of the process
    ! 4 kurtosis of the process
    ! 5 mean of the e
    ! 6 variance of the e
    ! 7 skewness of the e
    ! 8 kurtosis of the e
    ! 9 rho
	
	
    ! The process is simulated to print
    ! the moments of the differences
    CALL process2(inputpar,process)
    ! we compute the differences
    DiffProcess=Diff(process)	!This is basically used in EC method, it is here just for documenting the moments of the differences

    
    
    PRINT'(A31,F6.2,F6.2)','           mean of the process ',Targets(1) !we are not targeting
    PRINT'(A31,F6.2,F6.2)','       variance of the process ',Targets(2)
    PRINT'(A31,F6.2,F6.2)','       skewness of the process ',Targets(3)
    PRINT'(A31,F6.2,F6.2)','       kurtosis of the process ',Targets(4)
    PRINT'(A31,F6.2)','              mean of the diff ',mom1(DiffProcess)
    PRINT'(A31,F6.2)','          variance of the diff ',mom2(DiffProcess)
    PRINT'(A31,F6.2)','          skewness of the diff ',mom3(DiffProcess)
    PRINT'(A31,F6.2)','          kurtosis of the diff ',mom4(DiffProcess)       
    PRINT'(A31,F6.2,F6.2)','                 mean of the e ',Targets(5)
    PRINT'(A31,F6.2,F6.2)','             variance of the e ',Targets(6)
    PRINT'(A31,F6.2,F6.2)','             skewness of the e ',Targets(7)
    PRINT'(A31,F6.2,F6.2)','             kurtosis of the e ',Targets(8)
    PRINT'(A31,F6.2,F6.2)','                           rho ',Targets(9)
	PRINT *, ''
    
    CALL dlasrt('I',t,process,info)
    ! now that we have specified the continuous process
    ! that we are matching we start a loop that allows us to
    ! consider a state space with a number of states from 2 to 10
	
    DO ii=1,size(temp)
		start=0.0_dp
		CALL CPU_TIME(start)
        j=temp(ii)
        CALL SYSTEM_CLOCK(COUNT_RATE=clock_rate)
        CALL SYSTEM_CLOCK(COUNT=clock_start)
        ! now we set the number of states n and the number of restarts
        n=j
        print*,'number of states=',n
		PRINT '(A12,2A15,A15)','No of iter','criteria','percent dev','time'
		
        IF (n .LE. 5) THEN
            minpro=process(10*t/100)
            maxpro=process(90*t/100)
        ELSE IF (n .LE. 15) THEN
            minpro=process(10*t/100)
            maxpro=process(90*t/100)
        ELSE
            minpro=process(1*t/100)
            maxpro=process(99*t/100)
        END IF
        ! we allocate the necessary vectors
        ALLOCATE(RandomRestarts(n+1,n))
        ALLOCATE(Results(n+1))
        ALLOCATE(states(n+1,n))
        ALLOCATE(yy(n+1))
        ALLOCATE(transition(n,n))
		ALLOCATE(Results_vector(2*k/100,4))
		ALLOCATE(states_vector(2*k/100,n))
        Results(n+1)=1000.0_dp
        ! we set the tolerance for the amoeba
        ftol=10.0_dp**(-6.0_dp)
        ! we generate a list of initial simplex that are going
        ! to serve as starting point for the amoeba minimization algorithm
        ! the following loop allows us to find the optimal grid for each of 
        ! the k restarts that we have set
        DO h=1,k
            OPEN(UNIT=2,FILE='stop')
            READ(2,'(A4)') stopcond
            CLOSE(2)
            IF (stopcond .EQ. 'stop') EXIT            
            !RandomRestarts(:,:)=RandomSimplex(n,MINVAL(process)/(1.0_dp+((h-1)/k)*4.0_dp),MAXVAL(process)/(1.0_dp+((h-1)/k)*4.0_dp))
            RandomRestarts(:,:)=RandomSimplex(n,minpro,maxpro)
            ! we set the initial simplex
            states=RandomRestarts(:,:)
            DO i=1,n+1 
                yy(i)=ErrorFunction2(inputpar,targets,states(i,:)) !Different from EC code since targets and inputpar are not global,
																   !it is passed to error function
            END DO              
            ! we start the minimization
            CALL amoeba1(states,yy,ftol,iter,inputpar,targets)						
            ! we store the results of the minimization
            IF (Results(n+1) .GT. yy(1)) THEN
                Results(1:n)=states(1,:)
                Results(n+1)=yy(1)									
            END IF			
			IF (MOD(h,100) .EQ. 0) THEN
				finish=0.0_dp
				CALL CPU_TIME(finish)
				temp1=PerError(inputpar,targets,Results(1:n),detail)
				Results_vector(h/100,1)=REAL(h)
				Results_vector(h/100,2)=Results(n+1)
				Results_vector(h/100,3)=temp1
				Results_vector(h/100,4)=finish-start
				states_vector(h/100,:)=Results(1:n)	
				PRINT'(F12.1,2F15.8,F15.1)', Results_vector(h/100,:)	
			END IF							    
        END DO
        ! we store the minimum among all restarts performed
		!Instead of results, we call the best upto now as "best", this is an unnecessary variable
        best(1:n+1)=Results
        DO h=1,k
            OPEN(UNIT=2,FILE='stop')
            READ(2,'(A4)') stopcond
            CLOSE(2)
            IF (stopcond .EQ. 'stop') EXIT  
            RandomRestarts(:,:)=RandomSimplex(n,minpro,maxpro)        
            weight=(real(k-h+1)/real(k))
            DO i=1,n+1
                states(i,:)=RandomRestarts(i,:)*weight+best(1:n)*(1.0-weight)
            END DO
            DO i=1,n+1 
                yy(i)=ErrorFunction2(inputpar,targets,states(i,:))
            END DO    
            CALL amoeba1(states,yy,ftol,iter,inputpar,targets)           
			IF (best(n+1) .GT. yy(1)) THEN
                best(1:n)=states(1,:)
				best(n+1)=yy(1)
            END IF
			IF (MOD(h,100) .EQ. 0) THEN
				finish=0.0_dp
				CALL CPU_TIME(finish)
				temp1=PerError(inputpar,targets,best(1:n),detail)
				Results_vector((k+h)/100,1)=REAL(h)
				Results_vector((k+h)/100,2)=best(n+1)
				Results_vector((k+h)/100,3)=temp1
				Results_vector((k+h)/100,4)=finish-start
				states_vector((k+h)/100,:)=best(1:n)
				PRINT'(F12.1,2F15.8,F15.1)', Results_vector((k+h)/100,:)						
			END IF					
        END DO
        PRINT*,""
        PRINT*,""
        ! we write the result in a file
        CALL SYSTEM_CLOCK(COUNT=clock_end)
        elapsed_time=REAL(clock_end-clock_start)/REAL(clock_rate)
		
        WRITE (name,'(I2)') n
        OPEN(unit=7,file='criteria_iter'//name//'_'//s2)
		OPEN(unit=9,file='states_iter'//name//'_'//s2)
		WRITE(7,'(A12,2A15,A15)') 'No of iter','criteria','percent dev','time'
		
		DO i=1,2*k/100
			WRITE(7,'(F12.1,2F15.8,F15.1)') Results_vector(i,:)		
			WRITE(9,'('//name//'F11.5)') states_vector(i,1:n)
		END DO
		
        OPEN(unit=1,file='results'//name//'_'//s2)
        WRITE(1,*) "number of states"
        WRITE(1,'(I5)') n
        WRITE(1,*) ""       
        WRITE(1,*) "time elapsed: "
        WRITE(1,'(F9.3)') elapsed_time
        WRITE(1,*) ""       
        WRITE(1,*) "criterion: "
        WRITE(1,'(F9.3)') best(n+1)
        WRITE(1,*) ""       
        temp1=PerError(inputpar,targets,best(1:n),detail)
        WRITE(1,*) "percentage criterion"
        WRITE(1,'(F9.3)') temp1
        WRITE(1,*) ""
		WRITE(1,*) "Everything is targeted except E(y) and E(e)"
		WRITE(1,*) ""        
        WRITE(1,'(A31,A12,A10)') " detailed percentage criterion  ","perc. dev","target"
        WRITE(1,'(A31,F12.4,F10.3)') ' mean of the process            ',detail(1),Targets(1)
        WRITE(1,'(A31,F12.4,F10.3)') ' variance of the process        ',detail(2),Targets(2)
        WRITE(1,'(A31,F12.4,F10.3)') ' skewness of the process        ',detail(3),Targets(3)
        WRITE(1,'(A31,F12.4,F10.3)') ' kurtosis of the process        ',detail(4),Targets(4)
        WRITE(1,'(A31,F12.4,F10.3)') ' mean of the error              ',detail(5),Targets(5)
        WRITE(1,'(A31,F12.4,F10.3)') ' variance of the error          ',detail(6),Targets(6)
        WRITE(1,'(A31,F12.4,F10.3)') ' skewness of the error          ',detail(7),Targets(7)
        WRITE(1,'(A31,F12.4,F10.3)') ' kurtosis of the error          ',detail(8),Targets(8)
        WRITE(1,'(A31,F12.4,F10.3)') ' autocorrelation of the process ',detail(9),Targets(9)
		
        WRITE(1,*) ""       
        WRITE(1,*) "states"
        WRITE(1,'(F9.3)') best(1:n)
        CALL TransitionOneStep(inputpar,best(1:n),transition)
		WRITE(1,*) ""  
        WRITE(1,*) "transition prob"
        write(1,'('//name//'F9.5)') TRANSPOSE(transition)
		mm1=TransitionStates2Targets(transition,best(1:n))
		best(1:n)=best(1:n)-mm1(1)
        WRITE(1,*) ""       
        WRITE(1,*) "adjusted states"
        WRITE(1,'(F9.5)') best(1:n)
		WRITE(1,*) ""  
		WRITE(1,*) "stationary prob"
        write(1,'('//name//'F9.5)') stationary(transition)
        CLOSE(1)
		CLOSE(7)
		CLOSE(9)

        ! deallocating
        DEALLOCATE(RandomRestarts)
        DEALLOCATE(Results)
        DEALLOCATE(transition)
        DEALLOCATE(states)
        DEALLOCATE(yy)
		DEALLOCATE(Results_vector)
		DEALLOCATE(states_vector)
    END DO
    !CLOSE(1)
END PROGRAM




! what i want to fix or improve in this code
! - the min and max of search must change with the cardinality of the approximation
!     as a higher caridinality typically requires a bigger search area
! - i should try to find a more efficient way of looking for the minimum
!     maybe a sequential bisection approach, where states are added one by one